Attribute VB_Name = "modUtilita"
Option Explicit
'
Private Const MAXFIL& = 5   ' N. Massimo di Files recenti da
                            ' ricordare (0 < MAXFIL < 10).
'
Private Const SHARD_PATH As Long = &H2
Private Declare Function SHAddToRecentDocs Lib "Shell32.dll" _
(ByVal uFlags As Long, ByVal PV As String) As Long
'
' SysSep:
Private Const LOCALE_STHOUSAND& = &HF
Private Const LOCALE_SDECIMAL& = &HE
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" _
(ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String _
, ByVal cchData As Long) As Long
Private Declare Function GetThreadLocale Lib "kernel32" () As Long
Public Sub AddToRecentDocs(ByVal File As String)
'
'
    Dim R&
'
    If Dir(File, 6) <> "" Then
        R = SHAddToRecentDocs(SHARD_PATH, File)
    Else
        MsgBox "Impossibile trovare il file: " & File _
        , vbCritical, "Errore in AddToRecentDocs"
    End If
'
'
'
End Sub
Public Sub AggiornaFilesRecenti(ByVal mnuRecenti As Object, ByVal FileRec$)
'
'   Aggiunge al menu mnuRecenti() il file FileRec$.
'   mnuRecenti e' una voce di menu, con indice:
'   mnuRecenti(0) e' il titolo, i files da memorizzare
'   iniziano dalla posizione mnuRecenti(1).
'   Se FileRec$ e' gia' presente lo sposta al primo posto.
'   Deve essere dichiarata, nel modulo, la costante MAXFIL& che
'   corrisponde al numero massimo, voluto, di files recenti
'   da memorizzare (0 < MAXFIL < 10).
'
    Dim I&, F&, FILN&
    Dim a$, NuovoFile As Boolean
'
    If FileRec$ = "" Then Exit Sub
'
    FILN = mnuRecenti.UBound
'
    NuovoFile = True
    For F = 1 To FILN
        a$ = mnuRecenti(F).Caption
        If UCase$(Right$(a$, Len(a$) - 3)) = UCase$(FileRec$) Then
            NuovoFile = False
            Exit For
        End If
    Next F
    If F > FILN Then F = FILN
'
    If (FILN < MAXFIL) And NuovoFile Then
        FILN = FILN + 1
        F = FILN
        Load mnuRecenti(FILN)
        mnuRecenti(FILN).Visible = True
    End If
'
    mnuRecenti(0).Visible = (FILN > 0)
'
    For I = F To 2 Step -1
        a$ = mnuRecenti(I - 1).Caption
        a$ = "&" & Trim$(Str$(I)) & " " & Right$(a$, Len(a$) - 3)
        mnuRecenti(I).Caption = a$
    Next I
'
    mnuRecenti(1).Caption = "&1 " & FileRec$
'
'
'
End Sub
Public Sub LeggiFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$)
'
'   Legge i files recenti dal Registry di Windows
'   e li aggiunge al menu mnuRecenti():
'
    Dim I&, FileRec$
'
    For I = MAXFIL To 1 Step -1
        FileRec$ = GetSetting(App.ProductName, Sezione$, Str$(I), "")
        If FileRec$ <> "" Then
            AggiornaFilesRecenti mnuRecenti, FileRec$
        End If
    Next I
'
'
'
End Sub
Public Sub SalvaFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$)
'
'   Salva i files recenti, contenuti nel menu
'   mnuRecenti(), nel Registry di Windows:
'
    Dim I&, FileRec$
'
    For I = 1 To mnuRecenti.UBound
        FileRec$ = mnuRecenti(I).Caption
        FileRec$ = Right$(FileRec$, Len(FileRec$) - 3)
        SaveSetting App.ProductName, Sezione$, Str$(I), FileRec$
    Next I
'
'
'
End Sub

Public Function BreakDown(ByVal Full$, Optional ByRef PName$ _
    , Optional ByRef FName$, Optional ByRef Ext$) As Boolean
'
'   Scompone un nome di File completo di Path nelle sue parti:
'   Full$  = Nome completo del File.
'   PName$ = Path del File (con \ finale).
'   FName$ = Nome del File con Estensione.
'   Ext$   = .Estensione del File.
'
'   Se il File non esiste scompone il nome e ritorna False.
'
    Dim Sloc&, Dot&
'
    BreakDown = FileExists(Full$)
'
    If InStr(Full$, "\") Then
        FName$ = Full$
        PName$ = ""
        Sloc = InStr(FName$, "\")
        Do While Sloc <> 0
            PName$ = PName$ + Left$(FName$, Sloc)
            FName$ = Mid$(FName$, Sloc + 1)
            Sloc = InStr(FName$, "\")
        Loop
    Else
        PName$ = ""
        FName$ = Full$
    End If
'
    Dot = InStr(Full$, ".")
    If Dot <> 0 Then
        Ext$ = Mid$(Full$, Dot)
    Else
        Ext$ = ""
    End If
'
'
'
End Function
Private Function FileExists(ByVal FileN$) As Boolean
'
'   Verifica l' esistenza del file FileN$:
'
    Dim res&
'
    On Error Resume Next
'
    res = FileLen(FileN$)
    FileExists = (Err = 0)
    Err.Clear
'
'
'
End Function
Public Function KAscNumInteri(ByVal KA% _
    , Optional ByVal Neg As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero intero (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumInteri(KeyAscii [, Neg])
'
    Dim KeyMinus%, TextB As TextBox
'
    Const myKeyMinus% = 45  ' E' il valore effettivamente ritornato
                            ' alla pressione del tasto - ;
                            ' vbKeySubtract (= 109) non funziona.
'
    Set TextB = Screen.ActiveControl
'
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And Neg And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyMinus, vbKeyBack
        KAscNumInteri = KA
'
        Case Else
        KAscNumInteri = 0
    End Select
'
'
'
End Function
Private Sub GetLocale(ByRef DS$, Optional ByRef MS$)
'
'   Trova i separatori decimale e
'   delle migliaia del sistema:
'
    DS$ = "  "
    MS$ = "  "
'
    GetLocaleInfo GetThreadLocale(), LOCALE_SDECIMAL, DS$, Len(DS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STHOUSAND, MS$, Len(MS$)
'
    DS$ = Left$(DS$, 1)
    MS$ = Left$(MS$, 1)
'
'
'
End Sub
Public Function KAscNumReali(ByVal KA As Integer _
    , Optional ByVal Neg As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero reale (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Usa le impostazioni locali del separatore decimale.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumReali(KeyAscii [, Neg])
'
    Dim KeyDecimal%, KeyMinus%, TextB As TextBox
    Dim SD$, SM$, myKeyDecimal%
'
    Const myKeyMinus% = 45      ' E' il valore effettivamente ritornato
                                ' alla pressione del -;
                                ' vbKeySubtract (= 109)  non funziona.
    GetLocale SD$, SM$          ' Trova le impostazioni locali dei
    myKeyDecimal% = Asc(SD$)    ' separatori decimale e delle migliaia.
'
    Set TextB = Screen.ActiveControl
'
    If (InStr(TextB.Text, SD$) = 0 _
    And Not (TextB.SelStart = 0 And Left$(TextB.Text, 1) = "-")) _
    Or TextB.SelText = TextB.Text Then KeyDecimal = myKeyDecimal
'
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And Neg And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyDecimal, KeyMinus, vbKeyBack
        KAscNumReali = KA
'
        Case Else
        KAscNumReali = 0
    End Select
'
'
'
End Function

